rem    OutputFile: %2\%1.flavia.inf
rem    OutputFile: %2\%1-ramsolid.info
rem    ErrorFile: %2\%1.flavia.err
rem    ErrorFile: %2\%1-ramsolid.err
rem    WarningFile: %2\%1.flavia.war

tcl
proc LaunchTdynAndSSolver { basename dir problemtypedir } {
    global RunningProcess tcl_platform

    switch $::tcl_platform(platform) {
	"windows" { 
	    set tdynexe tdyn.exe
	    set ramexe ramsolid.exe
	}
	"default" { 
	    set tdynexe tdyn
	    set ramexe ramsolid
	}
    }

    foreach i [list .flavia.res .flavia.err .flavia] {
	file delete [file join $dir $basename$i]
    }
    foreach i [list .flavia.msh .flavia.res .dat .err .info .war] {
	file delete [file join $dir $basename-ramsolid$i]
    }
    file rename [file join $dir $basename.dat] [file join $dir $basename.flavia]
 
    set port 3000
#    set err [catch { socket -server "" $port } sock]
#    if { !$err } {
#        close $sock
#	set fout [open [file join $dir $basename.flavia.err] a]
#	puts $fout "Failed to open TCP-IP port in the range 3256-13256."
#	puts $fout "Contact your system administrator and check configuration of firewalls and anti-virus"
#	close $fout
#	return
#    }

    set exe [file join $problemtypedir "../scripts" $tdynexe]
    set dat [file join $dir $basename.flavia]
    set out [file join $dir $basename.flavia.out]
    set err1 [file join $dir $basename.flavia.err]

    set pid1 [exec $exe -name $dat -3d -coupling $port 10000 > $out &]

    set exe {C:\Documents and Settings\julio\Escritorio\st\E600_2004_11_09.exe}
    set dat {C:\Documents and Settings\julio\Escritorio\st\oooo.dat}

#    set pid2 [exec $exe $dat &]

    set RunningProcess running
    set ErrorInProcess "no"
    while 1 {
	if { $RunningProcess == "" } {
	    if { [isalive $pid1] } {  kill $pid1 }
	    vwait forever
	}
	if { ![isalive $pid1] & [file exists $err1] && [file size $err1] > 0 } {
	    kill $pid2
            set ErrorInProcess "yes"
	    break
	}
	after 200
	update
    }

    if { $ErrorInProcess=="no" } {
    	if { ![file exists [file join $dir $basename.flavia.res]] || \
		[file size [file join $dir $basename.flavia.res]] == 0 } {
		set fout [open [file join $dir $basename.flavia.err] a]
		puts $fout "Tdyn failed. Results are not available."
		close $fout
    	}
    }
}

switch $::tcl_platform(platform) {
    "windows" { 
	foreach "- - basename dir problemtypedir -" $argv break
    }
    "default" { 
	foreach "basename dir problemtypedir" $argv break
    }
}
LaunchTdynAndSSolver $basename $dir $problemtypedir
